Index: trunk/include/iprt/log.h
===================================================================
--- trunk/include/iprt/log.h	(revision 20853)
+++ trunk/include/iprt/log.h	(revision 20859)
@@ -220,9 +220,9 @@
     /** Pointer to temporary scratch buffer.
      * This is used to format the log messages. */
-    char                    achScratch[16384];
+    char                    achScratch[32768];
     /** Current scratch buffer position. */
-    RTUINT                  offScratch;
+    uint32_t                offScratch;
     /** This is set if a prefix is pending. */
-    RTUINT                  fPendingPrefix;
+    uint32_t                fPendingPrefix;
     /** Pointer to the logger function.
      * This is actually pointer to a wrapper which will push a pointer to the
@@ -235,11 +235,11 @@
     uint32_t                u32Magic;
     /** Logger instance flags - RTLOGFLAGS. */
-    RTUINT                  fFlags;
+    uint32_t                fFlags;
     /** Number of groups in the afGroups member. */
-    RTUINT                  cGroups;
+    uint32_t                cGroups;
     /** Group flags array - RTLOGGRPFLAGS.
      * This member have variable length and may extend way beyond
      * the declared size of 1 entry. */
-    RTUINT                  afGroups[1];
+    uint32_t                afGroups[1];
 };
 
@@ -257,9 +257,9 @@
     /** Pointer to temporary scratch buffer.
      * This is used to format the log messages. */
-    char                    achScratch[16384];
+    char                    achScratch[32768];
     /** Current scratch buffer position. */
-    RTUINT                  offScratch;
+    uint32_t                offScratch;
     /** This is set if a prefix is pending. */
-    RTUINT                  fPendingPrefix;
+    uint32_t                fPendingPrefix;
     /** Pointer to the logger function.
      * This is actually pointer to a wrapper which will push a pointer to the
@@ -279,7 +279,7 @@
     uint32_t                u32Magic;
     /** Logger instance flags - RTLOGFLAGS. */
-    RTUINT                  fFlags;
+    uint32_t                fFlags;
     /** Destination flags - RTLOGDEST. */
-    RTUINT                  fDestFlags;
+    uint32_t                fDestFlags;
     /** Handle to log file (if open). */
     RTFILE                  File;
@@ -292,11 +292,11 @@
     /** The max number of groups that there is room for in afGroups and papszGroups.
      * Used by RTLogCopyGroupAndFlags(). */
-    RTUINT                  cMaxGroups;
+    uint32_t                cMaxGroups;
     /** Number of groups in the afGroups and papszGroups members. */
-    RTUINT                  cGroups;
+    uint32_t                cGroups;
     /** Group flags array - RTLOGGRPFLAGS.
      * This member have variable length and may extend way beyond
      * the declared size of 1 entry. */
-    RTUINT                  afGroups[1];
+    uint32_t                afGroups[1];
 };
 
@@ -1313,7 +1313,7 @@
  * @param   ...                 Format arguments.
  */
-RTDECL(int) RTLogCreate(PRTLOGGER *ppLogger, RTUINT fFlags, const char *pszGroupSettings,
+RTDECL(int) RTLogCreate(PRTLOGGER *ppLogger, uint32_t fFlags, const char *pszGroupSettings,
                         const char *pszEnvVarBase, unsigned cGroups, const char * const * papszGroups,
-                        RTUINT fDestFlags, const char *pszFilenameFmt, ...);
+                        uint32_t fDestFlags, const char *pszFilenameFmt, ...);
 
 /**
@@ -1335,7 +1335,7 @@
  * @param   ...                 Format arguments.
  */
-RTDECL(int) RTLogCreateEx(PRTLOGGER *ppLogger, RTUINT fFlags, const char *pszGroupSettings,
+RTDECL(int) RTLogCreateEx(PRTLOGGER *ppLogger, uint32_t fFlags, const char *pszGroupSettings,
                           const char *pszEnvVarBase, unsigned cGroups, const char * const * papszGroups,
-                          RTUINT fDestFlags, char *pszErrorMsg, size_t cchErrorMsg, const char *pszFilenameFmt, ...);
+                          uint32_t fDestFlags, char *pszErrorMsg, size_t cchErrorMsg, const char *pszFilenameFmt, ...);
 
 /**
@@ -1357,7 +1357,7 @@
  * @param   args                Format arguments.
  */
-RTDECL(int) RTLogCreateExV(PRTLOGGER *ppLogger, RTUINT fFlags, const char *pszGroupSettings,
+RTDECL(int) RTLogCreateExV(PRTLOGGER *ppLogger, uint32_t fFlags, const char *pszGroupSettings,
                            const char *pszEnvVarBase, unsigned cGroups, const char * const * papszGroups,
-                           RTUINT fDestFlags, char *pszErrorMsg, size_t cchErrorMsg, const char *pszFilenameFmt, va_list args);
+                           uint32_t fDestFlags, char *pszErrorMsg, size_t cchErrorMsg, const char *pszFilenameFmt, va_list args);
 
 /**
@@ -1373,5 +1373,5 @@
  * @param   fDestFlags          The destination flags.
  */
-RTDECL(int) RTLogCreateForR0(PRTLOGGER pLogger, size_t cbLogger, PFNRTLOGGER pfnLogger, PFNRTLOGFLUSH pfnFlush, RTUINT fFlags, RTUINT fDestFlags);
+RTDECL(int) RTLogCreateForR0(PRTLOGGER pLogger, size_t cbLogger, PFNRTLOGGER pfnLogger, PFNRTLOGFLUSH pfnFlush, uint32_t fFlags, uint32_t fDestFlags);
 
 /**
@@ -1400,5 +1400,5 @@
  */
 RTDECL(int) RTLogCloneRC(PRTLOGGER pLogger, PRTLOGGERRC pLoggerRC, size_t cbLoggerRC,
-                         RTRCPTR pfnLoggerRCPtr, RTRCPTR pfnFlushRCPtr, RTUINT fFlags);
+                         RTRCPTR pfnLoggerRCPtr, RTRCPTR pfnFlushRCPtr, uint32_t fFlags);
 
 /**